// Buhai, Portela, Teulings, and van Vuuren: Returns to Seniority or Tenure?
#include <oxstd.h>
 // COLUMN NUMBER:			0		1		2		3		4		5		6			7			8		9		10		11		12		 13 			  14 				15
// VARIABLES FROM STATA:	idtrab;	idemp;	year;	tenure;	educ;	age;	logrank;	jobchange;	loc;	ind;	occup;	big;	dsize	 mean females 	  mean educ		  mean age

main()
{
	decl max_durations = 22;			  
	decl max_spells = 22;	

	decl i, x1 = <>, d1 = <>, t2 = <>, age = <>, educ = <>;

	for(i=1;i<=88;i++)		// PUT HERE THE NUMBER OF FILES	  for denmark, have to see after executing the first durationa file	 : I deliberately want to have 87 or 88 here.

	
	{

		println(i);
		decl filestr = sprint("dur_intermed_", i, ".fmt");
		decl hulp1 = loadmat(filestr);

		decl j=0;
		decl  x1 = <>, d1 = <>, t2 = <>, age = <>, educ = <>, amt = <>, sec = <>, occ = <>, big = <>, dsize = <>, jobsno = <>, mfe=<>, med=<>, mag=<>, fnr=<>, ong=<>;

		while (j<rows(hulp1))
		{
			decl hulp2 = selectifr(hulp1, hulp1[j][0] .== hulp1[][0]);
		
		
			if (rows(hulp2) .> 0)
			{
				decl hulp3 = exp(hulp2[][13+max_durations:]);			 
				decl hulp3s = exp(hulp2[][13:13+max_durations-1]);

				
				if (rows(hulp2) .> max_spells)
				{
					hulp2 = hulp2[:max_spells-1][];
				}
				t2 		= t2|(hulp2[][2]'-1) .* 12~-ones(1,max_spells-rows(hulp2));	//-1 here, differs from the version for Portugal	
				d1 		= d1|(hulp2[][3] .== 2)'~-ones(1,max_spells-rows(hulp2));
				educ 	= educ|hulp2[][4]'~-ones(1,max_spells-rows(hulp2));
				age 	=  age|hulp2[][5]'~-ones(1,max_spells-rows(hulp2));		
				amt 	=  amt|hulp2[][6]'~-ones(1,max_spells-rows(hulp2));
				sec 	=  sec|hulp2[][7]'~-ones(1,max_spells-rows(hulp2));
				occ 	=  occ|hulp2[][8]'~-ones(1,max_spells-rows(hulp2));
				big 	=  big|hulp2[][9]'~-ones(1,max_spells-rows(hulp2));

				mfe 	=  mfe|hulp2[][10]'~-ones(1,max_spells-rows(hulp2));
				med 	=  med|hulp2[][11]'~-ones(1,max_spells-rows(hulp2));
				mag 	=  mag|hulp2[][12]'~-ones(1,max_spells-rows(hulp2));
				
		
				fnr 	=  fnr|hulp2[][1]'~-ones(1,max_spells-rows(hulp2));
				
				

				decl j1, hulp4 = <>, hulp4s = <>;
				for(j1=0;j1<rows(hulp3);j1++)
				{
					hulp4 = hulp4~hulp3[j1][];
					hulp4s = hulp4s~hulp3s[j1][];
				}

				hulp4 = hulp4~exp(-ones(1,(max_spells - rows(hulp3)) .* columns(hulp3)));
				hulp4s = hulp4s~exp(-ones(1,(max_spells - rows(hulp3s)) .* columns(hulp3s)));
			
				x1 = x1|hulp4;
				dsize = dsize|hulp4s;
			}
			j+=rows(hulp2);
		}
				

		decl filestr1 = sprint("d1_intermed_", i, ".fmt");
		decl filestr2 = sprint("t2_intermed_", i, ".fmt");
		decl filestr3 = sprint("age_intermed_", i, ".fmt");
		decl filestr4 = sprint("educ_intermed_", i, ".fmt");
		decl filestr5 = sprint("x1_intermed_", i, ".fmt");
		decl filestr6 = sprint("amt_intermed_", i, ".fmt");
		decl filestr7 = sprint("occ_intermed_", i, ".fmt");
		decl filestr8 = sprint("sec_intermed_", i, ".fmt");
		decl filestr9 = sprint("big_intermed_", i, ".fmt");
		decl filestr10 = sprint("dsize_intermed_", i, ".fmt");

		decl filestr11 = sprint("women_firm_intermed_", i, ".fmt");
		decl filestr12 = sprint("educ_firm_intermed_", i, ".fmt");
		decl filestr13 = sprint("age_firm_intermed_", i, ".fmt");

		decl filestr14 = sprint("firm_intermed_", i, ".fmt");



		 savemat(filestr1, d1);
		 savemat(filestr2, t2);
		 savemat(filestr3, age);
		 savemat(filestr4, educ);
		 savemat(filestr5, x1);
		 savemat(filestr6, amt);
		 savemat(filestr7, occ);
		 savemat(filestr8, sec);
		 savemat(filestr9, big);
		 savemat(filestr10, dsize);
		 savemat(filestr11, mfe);
		 savemat(filestr12, med);
		 savemat(filestr13, mag);
		 savemat(filestr14, fnr);
		 
		

		}
		println(x1);
		
	return 1;
}
